#! /usr/bin/perl 
#       Script to parse a given 454AllDiff.txt file to generate percentage 
#       of mutation for all SNPs (except those which have more than one base at reference nucleotide
#       and more than three bases at variant nucleotide position in any summary line. If there 
#       are more than one and less than three bases at variant nucleotide position, bases 
#       should be non repetitive).
#
#
#
#       Usage:  perl allsnp.pl input_file_454AllDiff.txt > output_file.gff3
#
#       Same code works for any 454AllDiff.txt file
#
#       Surabhi, 8/30/2010
#
#
#	Copyright (c) 2010 Surabhi Nigam
#
#	Permission is hereby granted, free of charge, to any person obtaining a copy
#	of this software and associated documentation files (the "Software"), to deal
#	in the Software without restriction, including without limitation the rights
#	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#	copies of the Software, and to permit persons to whom the Software is
#	furnished to do so, subject to the following conditions:
#	
#	The above copyright notice and this permission notice shall be included in
#	all copies or substantial portions of the Software.
#	
#	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
#	THE SOFTWARE.
#	


sub process_diff {
            
     
          while(defined ($diff_line = <>)){
        
              my @first_line='';
              my $seqid='';
              my $start='';
              my $end='';
              my $percent=0;
              my @begin_strand='';
              my @second_line='';
     
                  if(substr($diff_line,0,1) eq '>'){
                     @first_line=split(/\s+/, $diff_line);
                     if($first_line[1] ne 'Start' && $first_line[1] ne 'Pos' ){
                     @ref_nuc=split(undef, $first_line[3]);
                     @var_nuc=split(undef, $first_line[4]);
                     $var_length=@var_nuc;
                     $ref_length=@ref_nuc;
if(($ref_length==1) && ($var_length==1) && ($ref_nuc[0] ne 'N') && ($ref_nuc[0] ne '-') && ($var_nuc[0] ne 'N') && ($var_nuc[0] ne '-') ) {
            
                     $seqid=substr($first_line[0],1);
                     $diff_line=<>;
                     $diff_line=<>;
                     $diff_line=<>;
                     @second_line=split(/\s+/, $diff_line);
                     @begin_strand=split(undef,$second_line[1]);
                                          if(($begin_strand[-1]eq '+' ) || ($begin_strand[-1]eq '-')){}
                                             else{$begin_strand[-1]='?';}        

   
                                          chop($first_line[6]);
                                          $percent=$first_line[6];
                                          $end=$first_line[2];
                                        
                                       
                            $SNP_bases=$first_line[4];

                       
                 
          

      print  "$seqid	SNP	remark	$first_line[1]	$end	$percent	$begin_strand[-1]	.	ID=$seqid:$first_line[1];Name=$seqid:$first_line[1]-$SNP_bases\n";
          }            
      }
   }        

           } #end of while

     }# end of sub routine

&process_diff;
